#
# spec file for package lttng-ust
#
# Copyright (c) 2016 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           lttng-ust
Version:        2.7.1
Release:        1.3
Source:         http://lttng.org/files/%{name}/%{name}-%{version}.tar.bz2
Patch1:         lttng-ust-copying.patch
Patch2:         lttng-ust-aarch64-aligned-access.patch
Summary:        Linux Trace Toolkit Userspace Tracer library
License:        GPL-2.0
Group:          Development/Languages/C and C++
BuildRequires:  gcc-c++
BuildRequires:  liburcu-devel
BuildRequires:  libuuid-devel
BuildRequires:  pkgconfig
BuildRequires:  texinfo
Url:            http://lttng.org/lttng2.0
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
ExclusiveArch:  aarch64 %ix86 x86_64

%description
This library may be used by user space applications to generate tracepoints within the kernel LTT subsystem.

%package -n %{name}-devel

Summary:        Linux Trace Toolkit Userspace Tracer library
Group:          Development/Languages/C and C++
Requires:       %{name} = %{version}-%{release}
Requires:       liburcu-devel

%description -n %{name}-devel
This library provides support for developing programs using LTTng userspace tracing

%package -n %{name}-docs

Summary:        Linux Trace Toolkit Userspace Tracer Documentation
Group:          Development/Languages/C and C++
Requires:       %{name} = %{version}-%{release}

%description -n %{name}-docs
This package includes documentation and examples for developing programs using LTTng userspace tracing

%prep
%setup -q 
%patch1 -p1
%patch2 -p1

%build
%configure --docdir=%{_docdir}/%{name} --disable-static --disable-maintainer-mode
make

%install
make DESTDIR=%buildroot install
rm -vf %buildroot%{_libdir}/*.la
rm -rf %{buildroot}/tmp/lttng-ust-divert

%clean
rm -rf %buildroot

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root)
%{_bindir}/lttng-gen-tp
%{_libdir}/*.so.*
%{_mandir}/man1/lttng-gen-tp.1.gz
%{_mandir}/man3/lttng-ust.3.gz
%{_mandir}/man3/lttng-ust-cyg-profile.3.gz
%{_mandir}/man3/lttng-ust-dl.3.gz

%files -n %{name}-devel
%defattr(-,root,root)
%{_prefix}/include/*
%{_libdir}/*.so
%{_libdir}/pkgconfig/lttng-ust*.pc

%files -n %{name}-docs
%defattr(-,root,root)
%dir %{_docdir}/%{name}
%{_docdir}/%{name}/ChangeLog
%{_docdir}/%{name}/README.md
%{_docdir}/%{name}/COPYING
%dir %{_docdir}/%{name}/examples
%{_docdir}/%{name}/examples/*
%{_docdir}/%{name}/java-agent.txt

%changelog
* Thu Jan 28 2016 tonyj@suse.com
- Update to relese version v2.7.1 for SLE12-SP2
  Changelog:
    http://git.lttng.org/?p=lttng-ust.git;a=blob_plain;f=ChangeLog;hb=v2.7.1
* Mon Oct  5 2015 tonyj@suse.com
- Update to relese version v2.7.0 (FATE#319273)
  See http://git.lttng.org/?p=lttng-ust.git;a=blob_plain;f=ChangeLog;hb=v2.7.0
  for changelog from v2.7.0-rc1 to v2.7.0
* Mon Aug 31 2015 dmueller@suse.com
- add lttng-ust-aarch64-aligned-access.patch (fate#318370)
  * enable build for aarch64
* Tue Jul 28 2015 tonyj@suse.com
- Update to version 2.7.0-rc1 (FATE#319273)
  Changelog for differences between 2.4.0 and this point may be found at:
    http://git.lttng.org/?p=lttng-ust.git;a=blob_plain;f=ChangeLog;hb=717e921558631baa4f132676eda9c9398fe7141f
* Tue Apr 15 2014 tonyj@suse.com
- Update to version 2.4.1
  Changelog:
  * Revert "Fix: disable liblttng-ust-dl if dlinfo is not available in C library"
  * Fix: .split() the CC environment variable in lttng-gen-tp
  * Fix: disable liblttng-ust-dl if dlinfo is not available in C library
  * Fix: python invocation through env
  * Fix: Override AM_PATH_PYTHON's default action-if-not-found
  * Fix: don't accept configure --disable-shared
  * Fix: configure.ac: add missing result to alignment req. check
  * Fix: malloc wrapper: infinite recursion with compat TLS
  * Fix: liblttng-ust-libc-wrapper recursive use of calloc
  * Fix: mismatch between code and comments
  * Fix: incorrect urcu git URL in README
* Fri Feb 28 2014 tonyj@suse.com
- Update to version 2.4.0. Changelog for changes between 2.3.0 and 2.4.0
  may be found at: http://git.lttng.org/?p=lttng-ust.git;a=blob_plain;f=ChangeLog;hb=refs/heads/stable-2.4
* Mon Feb 10 2014 tonyj@suse.com
- Update to version 2.3.1
* Thu Mar 14 2013 lpechacek@suse.com
- Include COPYING file in lttng-ust-docs
* Mon Mar 11 2013 tonyj@suse.com
- Upgrade to version 2.1.1 (FATE#314846)
  Changelog 2.1.1:
  * Introduce hash table for lttng_create_event_if_missing()
  * Fix: don't build C++ example if a C++ compiler isn't available
  Changelog 2.1.0:
  * Bump liblttng-ust-ctl lib version major number
  * Bump UST proto version minor number
  * Helper to debug: add object name
  * Tests: Fix rundir not created in ust-basic-tracing
  * ust test: add missing return -1
  * Test: update ust tracing unit tests to 2.1 internal ABI
  * Tests: Fix rundir not created in ust-multi-test
  * Adapt internal files and examples to TRACEPOINT_INCLUDE
  * Adapt tests to TRACEPOINT_INCLUDE
  * Cleanup: tests remove hello.cxx/ust_tests_demo.h
  * Fix: don't do macro expansion in tracepoint file name
  * Fix lttng-gen-tp: Template file must end in .tp
  * Pack structures in comm protocol between UST and sessiond
  * Cleanup lttng-gen-tp: Help not showing when using -h,--help
  * Cleanup lttng-gen-tp: remove leading underscore before include guard
  * fix memleak: ustctl free shadow chan on ustctl_unmap_channel()
  * Update license text
  * Fix: check if event enabled for bytecode-less events
  * Fix: handle enablers without bytecode
  * Print probe provider mismatch error even without -Wsystem-headers
  * filter: Add missing padding
  Changelog 2.1.0-rc2:
  * filter interpreter cleanup: use uint64_t for retval
  * Fix: filter linking can dereference NULL pointer on alloc failure
  * Cleanup: remove whitespaces and EOL in tests
  * Filter: use only single lower bit of filter return value
  * Fix: filter: var len array at end of external structure
  * Fix: filter link fail handling
  * Fix: add missing seqnum field to filter
  * filters: perform union rather than intersection
  * Implement support for overlapping wildcard/events
  * Cleanup: add lttng_/lttng-/LTTNG_ prefixes
  * filter: add seqnum field to filter command
  * Filter iteration: iterate on list of filters
  * document that tracepoint names should ideally not be re-used
  * Remove LIBFORMAT config declaration, unused
  * Add libc errno translation layer to UST error code
  * Fix: add const qualifier for filter local void *
  * Fix: re-allow non-lvalue string, sequence, array parameters
  * Tear down handles associated with a closed sessiond socket
  * Distinguish UST return codes from transport return codes
  * Fix: Conditionally disable tests requiring shared libs support
  * Cleanup: don't spawn per-user thread if HOME is not set
  * Manpage: document supported UST contexts
  * Fix: procname context semantic
  * Fix: Fix self-assign warning on struct ustfork_clone_info init
  * Fix: memcpy of string is larger than source
  * Implement liblttng-ust-fork daemon() override test
  * liblttng-ust-fork: override daemon() call
  * ustfork: set errno to ENOSYS if symbol lookup fails
  * Fix: be quiet on filter linker error
  * Build out of src tree
  * Fix: filter bytecode specializer stack leak
  * Fix: reloc offset validation error out on filters with no reloc table
  * Perform calculation on bit size in 64-bit
  * Use uint64_t for packet header content size and packet size
  * Fix: manpage typo "-lllttng-ust" -> "-llttng-ust"
  * Fix: BSD getprogname null pointer dereference
  * Add support for model.emf.uri event info
  * Filter error message cleanup
  * Manpage update: document use in daemons
  * Fix: get_wait_shm() ust mutex deadlock (add 2 missing exit calls)
  * Fix: get_wait_shm() ust mutex deadlock
  * Fix: add events with 0 field to field list
  Changelog 2.1.0-rc1:
  * Fix make dist: fix liblttng-ust-java dependencies
  * Fix make dist: add missing filter header
  * Fix: backward compatibility with UST 2.0 app probes
  * Fix: Filter ABI changes to support FILTER_BYTECODE_MAX_LEN (65536)
  * Export "written" information about fields
  * Fix filter: pointer to string, not string, should be on stack
  * Fix: tracepoint float nowrite
  * Fix: accept 65536 bytes long bytecodes
  * Add hostname to env
  * ABI change: bump internal version to 3.0.0
  * Fix: threads should be created in DETACHED state
  * Fix: 32-bit x86 strict-aliasing warnings
  * Fix UST SIGPIPE handling
  * Fix: Libtool fails to find dependent libraries when cross-compiling lttng-ust
  * Cleanup: filter: turn bytecode linking error msg into debug
  * Make lttng-ust robust against -finstrument-functions.
  * Filter: keep aliased ax and bx registers
  * Filter: remove interpreter dynamic typing
  * Filter: add missing specialized op names
  * Filter: specialize double-s64 binary comparators
  * Fix filter: fix stack leak on taken branch
  * Filter: Implement stack-based interpreter
  * Filter: double comparator produces s64
  * Filter: use hash table to check merge points
  * Filter: split passes into separate components
  * Filter: cleanup macros
  * Filter: validate range overflow with end of insn
  * Filter: validate that field ref strings are non-NULL
  * Filter: ensure logical operator merge is always s64
  * Filter: we don't care if double/s64 are literals
  * Filter: specialize 'and' and 'or' ops.
  * Implement dispatch-table based interpretor
  * Filter: Specialize unary operators
  * Define switch use as macro in interpreter
  * Filter interpreter: mark float test as unlikely
  * Filter: fix bytecode validation typo
  * Filter: specialize comparators
  * Specialize load and unary ops
  * Validate registers, no need to initialize to 0
  * Filter: opcode for ref loads
  * Remove redundant validation from interpreter
  * filter: Add bytecode validation pass
  * TRACEPOINT_EVENT: add *_nowrite fields for filter
  * Only print filter errors if LTTNG_UST_DEBUG is set
  * Cleanup: remove debug define
  * Filter: add floating point support
  * Remove filter test printouts
  * Implement filter bytecode interpreter and linker
  * Filter: receive, attach and link empty filter
  * Filter: prepare filter stack data
  * Wrap dynamic len array into stackvar union
  * liblttng-ust-comm/lttng-ust-com.c: remove unnecessary goto in ustcomm_accept_unix_sock()
  * liblttng-ust/lttng-ust-comm.c: fixing typo.
  * Fix: remove unused texinfo dep from configure.ac
  * Fix C99 strict compatibility: don't use void * for function pointers
  * Fix c99 compatibility: tp_rcu_dereference_bp() should not use braced-groups within expressions
  * Revert "Fix c99 compatibility: tp_rcu_dereference_bp() should not use braced-groups within expressions"
  * Fix c99 compatibility: tp_rcu_dereference_bp() should not use braced-groups within expressions
  * Fix: perform TLS fixup of nest count outside of UST mutex
  * Fix: liblttng-ust-fork deadlock
  * Fix: handle pthread errors
  * Fix: local apps allowed should disable local (not global) tracing
  * Fix strict ISO-C compatibility for ust-tracepoint-event.h public header
  * Fix: support -std=c99 in tracepoint macros
  * Fix c99 compatibility: use __typeof__ instead of typeof in public headers
  * hello test: fail on old style definition
  * Fix: tracepoint.h should not generate old-style definitions
  * Fix: don't define variables in headers
  * test "hello": add boolean test
  * Fix: perform macro expansion on tracepoint signatures
  * UST check pointer/de-reference order
  * Fix list field: handle error
  * Implement event fields listing
  * Implement field listing command
  * Fix: Block all signals in listener thread
  * Add CodingStyle document to tarball
  * Add coding style document
  * endian.h: support cygwin
  * align.h: support cygwin page size
  * Add cygwin support to libringbuffer getcpu.h
  * Add "2x int" and "2x long" types to the Java interface
  * Add Integer and Long tracepoint types to the Java interface
  * Fix: don't SIGBUS when filesystem is full
  * tracepoint: include stdio.h for NULL definition
  * manpage update: document that probes need gcc
  * Fix: remove # in front on extern "C" {
  * Cleanup: don't use GNU old-style field designator extension
  * Fix: remove padding field after variable sized array
  * Use unsigned long type for events discarded counter
  * Fix: getcpu build with modern uClibc versions
  * Fix: lttng-ust.pc needs to specify -ldl
  * Fix: examples Makefiles should pass $(LIBS) at last
  * Build a jar for the Java side of the JNI interface
  * Fix: ustctl need to send the second fd upon error of 1st fd
  * Fix: Add missing fork test program dependency library
  * Fix: Make the JNI interface actually work
  * Merge branch 'dev'
  * Fix: stringify version description
* Thu Jun 21 2012 tonyj@suse.com
- Update to release 2.0.4
* Thu Jun 14 2012 ro@suse.de
- change specfile license to GPL-2.0
* Mon Jun  4 2012 tonyj@suse.com
- Update to release 2.0.3
* Fri Apr 20 2012 tonyj@suse.com
- Update to release 2.0.2
* Thu Apr 12 2012 tonyj@suse.com
- Update to release 2.0.1
* Thu Mar 22 2012 tonyj@suse.com
- Update to release 2.0.0
* Wed Mar 14 2012 tonyj@suse.com
- Update to version 2.0.0-rc2
* Mon Feb 27 2012 tonyj@suse.com
- Update to version 2.0.0-rc1
* Wed Jan  4 2012 tonyj@suse.com
- Update to version 1.9.4
